<template>
  <div id="products">
    <div v-if="products.length === 0">
      <label>loading...</label>
    </div>
    <div v-else>
      <div class="products-result">
        <div>
          <div class="result-count">{{`ผลลัพธ์ ${productsTotal} ชิ้น`}}</div>
          <template v-for="(tag, index) in $store.getters.catalog.category.concat($store.getters.catalog.brands)">
            <div class="filter-result" :key="index">
              <span class="tag-name">{{tag.name}}</span>
              <span class="tag-close" @click="deleteTag(tag)">X</span>
            </div>
          </template>
        </div>
      </div>
      <div class="row">
        <div class="col-xs-12 col-sm-6 col-md-4 col-xl-3" v-for="(product, index) in products" :key="index">
          <v-card class="mx-auto custom-card">
            <div class="product-image">
              <v-img v-if="product.brand.image_url" :src="product.brand.image_url" />
              <v-img v-else :src="require('~/assets/images/no-image.png')" />
            </div>
            <div class="product-detail">
              <h5 class="product-name">{{product.name}}</h5>
              <div class="product-price">{{`฿ ${product.sku.price}`}}</div>
            </div>
          </v-card>
        </div>
      </div>
      <div class="pagination-box">
        <v-pagination
          v-model="page"
          :length="pageLength"
          :disabled="disablePage"
          style="width: 450px"
          color="#22457b"
        ></v-pagination>
      </div>
    </div>
  </div>
</template>

<script>
  import { mapActions } from 'vuex'

  export default {
    name: "products",
    data() {
      return {
        products: [],
        productsTotal: 0,
        items: 5,
        page: 1,
        tags: [],
        pageLength: 1,
        categoryId: [],
        brandsId: [],
        disablePage: false
      }
    },
    watch: {
      page(value) {
        const vm = this
        vm.getProducts(value)
      },
      '$store.getters.catalog.categoryAndBrandsId.categoryId'(value) {
        const vm = this
        vm.categoryId = value
        vm.page = 1
        vm.getProducts()
      },
      '$store.getters.catalog.categoryAndBrandsId.brandsId'(value) {
        const vm = this
        vm.brandsId = value
        vm.page = 1
        vm.getProducts()
      }
    },
    mounted() {
      this.getProducts()
    },
    methods: {
      ...mapActions({
        setBrands: 'setBrands',
        setCategory: 'setCategory'
      }),
      getProducts(page) {
        const vm = this
        page ? vm.disablePage = true : ''
        const dataQuery = {
          category_id:  vm.categoryId.length > 0 ? vm.categoryId.toString() : null,
          brand_id: vm.brandsId.length > 0 ? vm.brandsId.toString() : null,
          page: page ? page : 1
        }
        vm.$axios.$get('/catalog/products', { params: dataQuery })
          .then((res) => {
            vm.products = res.data.data
            vm.productsTotal = res.data.meta.total
            vm.pageLength = res.data.meta.last_page
          })
          .catch((e) => {
            alert(e.message)
          })
          .finally(() => {
            page ? vm.disablePage = false : ''
          })
      },
      deleteTag (value) {
        const vm = this
        const tagsCategory = Object.assign([], vm.$store.getters.catalog.category)
        const tagsBrands = Object.assign([], vm.$store.getters.catalog.brands)
        const deleteIndexCategory = tagsCategory.findIndex(e => e.id === value.id)
        const deleteIndexBrands = tagsBrands.findIndex(e => e.id === value.id)
        if (deleteIndexCategory > -1) {
          tagsCategory.splice(deleteIndexCategory, 1)
          vm.setCategory(tagsCategory)
        }
        if (deleteIndexBrands > -1) {
          tagsBrands.splice(deleteIndexBrands, 1)
          vm.setBrands(tagsBrands)
        }
      }
    }
  }
</script>

<style lang="scss" scoped>
  #products {
    .products-result {
      display: flex;
      align-items: center;
      min-height: 41px;
      .result-count {
        font-size: 14px;
        display: inline-block;
        margin-bottom: 7px;
      }
      .filter-result {
        display: inline-block;
        justify-content: space-between;
        align-items: center;
        position: relative;
        border: 1px solid #d1d1d2;
        line-height: 1;
        margin-left: 10px;
        margin-bottom: .625rem;
        font-size: 13px;
        padding: .4375rem;
        .tag-name {
          margin-right: 7px;
        }
        .tag-close {
          cursor: pointer;
        }
      }
    }
    .custom-card {
      display: flex;
      flex-direction: column;
      height: 17.5rem;
      padding: .625rem 15px;
      align-items: stretch;
      justify-content: space-between;
      @media (min-width: 583px) {
        width: 306px;
      }
      .product-image {
        width: 100%;
        height: 100%;
        align-items: center;
        justify-content: center;
        display: flex;
        max-height: 11.25rem;
        overflow: hidden;
      }
      .product-detail {
        .product-name {
          margin: 5px 0;
          max-height: 2.25rem;
          overflow: hidden;
        }
        .product-price {
          color: #1653ba;
          font-size: 1.125rem;
        }
      }
    }
    .pagination-box {
      float: left;
      margin-top: 30px;
      margin-left: -10px;
    }
  }
</style>
